/****************************************************************************
    BSch3V schematic capture
    Copyright (C) 1997-2014 H.Okada
*****************************************************************************/

/****************************************************************************
** XBSch}ʗvfC[WIuWFNg
****************************************************************************/
#ifndef XBSCHIMAGEOBJ_H
#define XBSCHIMAGEOBJ_H

#include "xbsch.h"
#include "xbschobj.h"

class SImageData;

#define IMAGEOBJ_MIN_MAGNIFICATION  5
#define IMAGEOBJ_MAX_MAGNIFICATION 200


class SXBSchImageObj :	public SXBSchObj
{
public:
	SXBSchImageObj(void);
	virtual ~SXBSchImageObj(void);

	bool readCe3(SReadCE3&,const SPoint* ,SXBSchDoc* );
	bool writeCe3(SWriteCE3& ,const SPoint* );


protected:
	SImageData*	m_pImageData;
	int m_drawMagnification;

protected:
	void DeleteImageData();


public:
	int		ImageWidth();
	int		ImageHeight();
	int		DrawMagnification(){return m_drawMagnification;}
	void	SetDrawMagnification(int n);
	const SImageData* ImageData(){return m_pImageData;}

	bool LoadDIB(const TCHAR* fname);
	bool LoadClipboardDIB(byte* buff, int clipBoardDataSize);

public:
	bool keepOrder(){return true;}

public:
	//ID̎擾
	unsigned id(){return ID_IMAGEOBJECT;}
	unsigned objectFilterValue(){return OBJMASK_IMAGE;} 
	//s
	SXBSchObj* duplicate();

	//W̐ݒ  m_p2ւ̐ݒ𖳌ɂĂ
	void setX2(int){}
	void setY2(int){}
	void setP2(const SPoint&){}
	//E]s
	void mirrorH(){}	//Ȃ
	//]s
	void rotate(){}		//Ȃ

	//L͈͂Ԃ
	SRect area();
	SRect rotateRect();


	//_w肵đIdvxԂ
	int qSelectWeight(const SPoint& p);
	//͈͂w肵đIs
	unsigned testSelection(const SRect& rc);
	//͈͂IăhbOIs
	unsigned testSelectionForDrag(const SRect& rc);
	//`悪KvǂԂ
	bool qRedraw(const SRect& rc);

	//PƑÎƂɃ~[\ǂԂ
	bool canMirrorSingleSelected() {return false;}
	//PƑÎƂɉ]\ǂԂ
	bool canRotateSingleSelected() {return false;}	
	//Agr[g̕ύX\ȏꍇtrueԂB
	bool canAttribute(){return true;}

};
#endif
